import '../lib/properties.dart';
import 'dart:io';

String path = '/Users/kevin/Documents/workspace/properties-cl-test/resources/sample.properties';
String path2 = '/Users/kevin/Documents/workspace/properties-cl-test/resources/sample-conversion.properties';

void list(List<int> bytes){
for(var i = 0; i < bytes.length; i++){
    
    print("${bytes[i]} (${new String.fromCharCode(bytes[i])})");
    
  }
}

bool contains(List<int> bytes, int c){
  
  
  for(var i = 0; i < bytes.length; i++){
    
    print("${bytes[i]} (${new String.fromCharCode(bytes[i])}) == ${c}");
    
    if(bytes[i] == c){
      return true;
    }
  
  }
  
  return false;
}

List<List<int>> getLines(List<int> bytes){
  List<List<int>> result = [];
  List<int> line = [];
  
  var nl = '\n'.charCodes[0];
  
  for(var i = 0; i < bytes.length; i++){
    
    if(bytes[i] != nl){
      line.add(bytes[i]);
    } else {
      result.add(line);
      line = [];
    }
    
    if(i == bytes.length -1)
      result.add(line);
  
  }
  
  return result;
}

bool endsWith(List<int> line, int char){
  print("input line: ${new String.fromCharCodes(line)}");
  return line.lastIndexOf(char) == (line.length -1);
}

List<int> replaceLastOccurrence(List<int> line, int toReplace, int replacer){
  List<int> result = [];
  bool replace = false;
  int limit = line.length;
  
  if(line.lastIndexOf(toReplace) == (line.length -1)){
    replace = true;
  }
  
  for(int i = 0; i < limit; i++){
    if(replace && (i == limit-1)){
      result.add(replacer);  
    } else {
      result.add(line[i]);
    }
  }
  
  return result;
}

List<List<int>> splitKeyValue(List<int> line){
  
  List<List<int>> result = [];
  List<int> key = [];
  List<int> value = [];
  
  var equal = '='.charCodes[0];
  
  bool isKey = true;
  
  for(var i = 0; i < line.length; i++){
    
    if(line[i] == equal && isKey){
      isKey = false;
    } else {
      if(isKey){
        key.add(line[i]);
      } else {
        value.add(line[i]);
      }
    }
  }
  
  result.add(key);
  result.add(value);
  
  return result;
}

void main() {
  
  var slash = '\\'.charCodes[0];
  var space = ' '.charCodes[0];
  
  var file = new File.fromPath(new Path(path));
  List<int> bytes = file.readAsBytesSync();
  var lines = getLines(bytes);
  
  var resultingLines = [];
  var app = [];
  bool isMultiLine = false;
  bool added = false;
  
  for(List<int> l in lines){
    
    if(isMultiLine){
      app.addAll(replaceLastOccurrence(l, slash, space));
      added = true;
    }
    
    if(endsWith(l, slash))
      isMultiLine = true;
    else {
      isMultiLine = false;
    }
    
   
    if(!isMultiLine){
      if(!app.isEmpty){
        resultingLines.add(app);
        app = [];
      } else {
        resultingLines.add(l);
      }
    }
    
    if(isMultiLine && !added){
      app.addAll(replaceLastOccurrence(l, slash, space));
    }
    
    added = false;
    
  }
  
  for(List<int> l in resultingLines)
    print("* ${new String.fromCharCodes(l)}");
  
  print(" ******************************** ");
  
  var map = new Map<String,String>();
  for(List<int> l in resultingLines){
    List<List<int>> splitted = splitKeyValue(l);
    map[new String.fromCharCodes(splitted[0])] = new String.fromCharCodes(splitted[1]);
  }
  
  print("${map}");
}
